#!/bin/sh

RENO=TcpNewReno
NOORD=TcpNoordwijk
RENOMW=${RENO}Mw
NOORDMW=${NOORD}Mw
PARAM="--EnableQueueStatistics --LanStopTime=1800.0 --SegmentSize=500"
STARTSTOP="0.0;1800.0"

# $1: --EnableMW (or empty)
# $2: Tcp Type
# $3: Queue size
# $4: Output file name
# $5: SatBw
run()
{

  cmdLine2="c2ml-lan $PARAM --QueueSize=$3 \
  --QueueDataFileName=${4}_2nodes $1 --SatelliteStringBandwidth=$5 \
  --NodeConfiguration=0;ns3::$2;$STARTSTOP \
  --NodeConfiguration=1;ns3::$2;$STARTSTOP 2>${2}_2nodes.txt"

  cmdLine4="c2ml-lan $PARAM --QueueSize=$3 \
      --QueueDataFileName=${4}_4nodes $1 --SatelliteStringBandwidth=$5 \
  --NodeConfiguration=0;ns3::$2;$STARTSTOP \
  --NodeConfiguration=1;ns3::$2;$STARTSTOP \
  --NodeConfiguration=2;ns3::$2;$STARTSTOP \
  --NodeConfiguration=3;ns3::$2;$STARTSTOP 2>${2}_4nodes.txt"

  cmdLine8="c2ml-lan $PARAM --QueueSize=$3 $1 \
      --QueueDataFileName=${4}_8nodes --SatelliteStringBandwidth=$5 \
  --NodeConfiguration=0;ns3::$2;$STARTSTOP \
  --NodeConfiguration=1;ns3::$2;$STARTSTOP \
  --NodeConfiguration=2;ns3::$2;$STARTSTOP \
  --NodeConfiguration=3;ns3::$2;$STARTSTOP \
  --NodeConfiguration=4;ns3::$2;$STARTSTOP \
  --NodeConfiguration=5;ns3::$2;$STARTSTOP \
  --NodeConfiguration=6;ns3::$2;$STARTSTOP \
  --NodeConfiguration=7;ns3::$2;$STARTSTOP 2>${2}_8nodes.txt"

  cmdLine16="c2ml-lan $PARAM --QueueSize=$3 $1 \
      --QueueDataFileName=${4}_16nodes --SatelliteStringBandwidth=$5 \
  --NodeConfiguration=0;ns3::$2;$STARTSTOP \
  --NodeConfiguration=1;ns3::$2;$STARTSTOP \
  --NodeConfiguration=2;ns3::$2;$STARTSTOP \
  --NodeConfiguration=3;ns3::$2;$STARTSTOP \
  --NodeConfiguration=4;ns3::$2;$STARTSTOP \
  --NodeConfiguration=5;ns3::$2;$STARTSTOP \
  --NodeConfiguration=6;ns3::$2;$STARTSTOP \
  --NodeConfiguration=7;ns3::$2;$STARTSTOP \
  --NodeConfiguration=8;ns3::$2;$STARTSTOP \
  --NodeConfiguration=9;ns3::$2;$STARTSTOP \
  --NodeConfiguration=10;ns3::$2;$STARTSTOP \
  --NodeConfiguration=11;ns3::$2;$STARTSTOP \
  --NodeConfiguration=12;ns3::$2;$STARTSTOP \
  --NodeConfiguration=13;ns3::$2;$STARTSTOP \
  --NodeConfiguration=14;ns3::$2;$STARTSTOP \
  --NodeConfiguration=15;ns3::$2;$STARTSTOP 2>${2}_16nodes.txt"

  cmd="parallel \"python2 ./waf --run \" ::: \"$cmdLine2\" \"$cmdLine4\" \"$cmdLine8\" \"$cmdLine16\""

#  echo $cmd
  eval $cmd
}

noordwijk()
{
  echo "Running Noordwijk 225 queue"
  run "" ${NOORD} 225 noordwijk-standard-queue "256KBps" &

  echo "Running Noordwijk 10000 queue"
  run "" ${NOORD} 10000 noordwijk-inf-queue "256KBps" & 

  wait
}


middleware()
{
  echo "Running MW 225 queue"
  run "--EnableMW" ${NOORDMW} 225 noordwijk-mw-standard-queue "265KBps" &
  echo "Running MW 10000 queue"
  run "--EnableMW" ${NOORDMW} 10000 noordwijk-mw-inf-queue "272KBps" &

  wait
}

python2 ./waf

if [ ! $? -eq 0 ]; then
    echo "Compiling FAILED."
    exit 1
fi

noordwijk
middleware
