#!/bin/sh

RENO=TcpNewReno
NOORD=TcpNoordwijk
RENOMW=${RENO}Mw
NOORDMW=${NOORD}Mw
PARAM="--EnableQueueStatistics --EnablePcap --LanStopTime=1800.0 --SegmentSize=1000"
STOP="1800.0"

# $1: --EnableMW (or empty)
# $2: Tcp Type
# $3: Queue size (bytes=size*(segmentsize+60)
# $4: output file name (no extension)
run()
{
  cmdLine="python2 ./waf --run \"c2ml-lan $PARAM --QueueSize=$3 $1 \
      --QueueDataFileName=\"${4}-queue.data\" --PcapPrefix=$4 \
  --NodeConfiguration=0;ns3::$2;0.0;$STOP \
  --NodeConfiguration=1;ns3::$2;10.0;$STOP \
  --NodeConfiguration=2;ns3::$2;20.0;$STOP \" 2>${4}.txt"

  echo "Running ${cmdLine}..."
  eval $cmdLine
  if [ $? != 0 ]; then
      echo "FAILED $4"
      exit 1
  fi
  echo "Done."
}


python2 ./waf -j8

run "" $NOORD 112 noordwijk-standard-throughput &
run "" $NOORD 10000 noordwijk-infinite-throughput &
run "--EnableMW" $NOORDMW 112 noordwijk-mw-standard-throughput &
run "--EnableMW" $NOORDMW 10000 noordwijk-mw-infinite-throughput &

wait

